local lg =  love.graphics
local small_canvas_size = 100
local needs_resize = false

function love.load ()
	small_canvas = lg.newCanvas(small_canvas_size, small_canvas_size)
	big_canvas = lg.newCanvas(small_canvas_size * 4, small_canvas_size * 4)
	counter = 0
	lg.setCanvas(small_canvas)
	render_small_canvas()
	lg.setCanvas(big_canvas)
	render_big_canvas()
	lg.setCanvas()
end

function render_small_canvas ()
	lg.setColor(0, 1, 0, 1)
	lg.rectangle('fill', 1, 1, small_canvas_size, small_canvas_size)
	lg.setColor(1, 0, 0, 1)
	lg.circle('fill', small_canvas_size / 2, small_canvas_size / 2, small_canvas_size / 2)
	lg.setColor(1, 1, 1, 1)
end

function render_big_canvas ()
	lg.draw(small_canvas, 0, 0)
	lg.draw(small_canvas, small_canvas_size, 0)
	lg.draw(small_canvas, 0, small_canvas_size)
	lg.draw(small_canvas, small_canvas_size, small_canvas_size)
	lg.setColor(1, 1, 1, 1)
end

function love.draw ()
	if needs_resize then
		print("resize")
		small_canvas:release()
		big_canvas:release()
		small_canvas = lg.newCanvas(small_canvas_size, small_canvas_size)
		big_canvas = lg.newCanvas(small_canvas_size * 4, small_canvas_size * 4)
		lg.setCanvas(small_canvas)
		render_small_canvas()
		lg.setCanvas(big_canvas)
		render_big_canvas()
		lg.setCanvas()
		needs_resize = false
	end
	lg.draw(small_canvas, 0, 0)
	lg.draw(big_canvas, small_canvas_size + 50, 0)
end

function love.resize ()
	needs_resize = true
end

function love.update (dt)
	if love.keyboard.isDown("escape") then
		love.event.quit()
	end
end
